<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Stoppuhr</title>
    <style>
    </style>

</head>
<body>
    <script type="module">
        import { LitElement, html } from 'https://unpkg.com/lit-element/lit-element.js?module';
        
        class Stoppuhr extends LitElement {
            static properties() { return {
                currentTime: {type: Number, reflect: true},
                currentTimeString: {type: String, reflect: true},
                isActive: {type: Boolean},
                //timeToString: {type: Function}
            };}

            constructor() {
                super();
                this.currentTime = 0;
                
                var timeToString = () =>
                {
                    var timehours = Math.round(this.currentTime / (60 * 60 * 1));
                    var timehourstring = ""+timehours;
                    if(timehours < 10)
                        timehourstring = "0" + timehours;

                    var timemins = Math.round(this.currentTime / (60 * 1)) % 60;
                    var timeminsstring = ""+timemins;
                    if(timemins < 10)
                        timeminsstring = "0" + timemins;

                    var timesecs = (this.currentTime / 1) % 60;
                    var timesecstring = ""+ timesecs;
                    if(timesecs < 10)
                        timesecstring = "0" + timesecs;
                    var result = `${timehourstring}:${timeminsstring}:${timesecstring}`;
                    return result;
                }

                this.currentTimeString = timeToString(this.currentTime);
                this.isActive = false;

                var update = () =>
                {
                    if(this.isActive)
                        this.currentTime++;
                    this.currentTimeString = timeToString(this.currentTime);
                    this.setAttribute('currentTimeString', timeToString(this.currentTime));
                    console.log("interval " + this.isActive + " " + this.currentTimeString);
                    super.update();
                }

                setInterval(function()
                {
                    update()
                }, 1000);
            }       

            render() {
                return html`
                    <p>Zeit: <span>${this.currentTimeString}</span></p>
                    <div id="start"  class="button" @click="${this.start}">Start</div>
                    <div id="stop"   class="button" @click="${this.stop}">Stop</div>
                    <div id="resume" class="button" @click="${this.resume}">Resume</div>
                    <div id="reset"  class="button" @click="${this.reset}">Reset</div>
                    <table></table>
                    `;
            }

            start()
            {
                console.log("start" + this.isActive);
                if(this.currentTime === 0)
                    this.isActive = true;
            }
            stop()
            {
                console.log("stop" + this.isActive);
                this.isActive = false;
            }
            resume()
            {
                console.log("resume" + this.isActive);
                if(this.currentTime != 0)
                    this.isActive = true;
            }
            reset()
            {
                console.log("reset" + this.isActive);
                if(this.isActive === false)
                    this.currentTime = 0;
            }     
                   
        }
        customElements.define('stopp-uhr', Stoppuhr)
    </script>
    <stopp-uhr></stopp-uhr>
</body>
</html>